;/===========================RANDOM Routine=================================\
;|					  			            |
;|	Input: 		b=upper bound 		                     	    |
;|		   	c=lower bound                                	    |
;|			d=sign wanted (0=Positive , 1=Negative)       	    |
;|								      	    |
;|	Output:		op1=integer number between 		     	    |
;|		   	upper bound and lower bound      	     	    |
;|								     	    |
;|  Coded by: Goncalo Almeida	   Version 1.1	   mail: jnalmeida@usa.net  |
;|								     	    |
;|  Use this "at will", as long as you give me some credit.                 |
;|								     	    |
;\==========================================================================/
RANDOM_ROUTINE:
	push de			;saves wanted sign
	push bc			;saves range
	call _zerooop1		;clears op1
	call _random		;generates random number ranging 0-1 in op1

	pop bc			;loads range
	ld a,b			;
	sub c			;subtracts upper bound and lower bound

	push bc			;saves range
	call _setxxop2		;puts the difference to op2
	call _FPmult		;multiplies op1 and op2
	call _Int		;converts op1 to integer
	pop bc			;loads range again	
	ld a,c			;

	call _setxxop2		;puts lower bound to op2
	call _FPADD		;adds op1 and op2
	
	pop de			;loads wanted sign
	ld a,d			;
	
	cp 0			;Sign wanted=positive?
	jp z,RANDOM_ROUTINE_END	;If yes , go to the end

	call _invop1S		;If no, negate op1

RANDOM_ROUTINE_END:
	ret			;returns to program
;============================RANDOM Routine==================================